# Copyright (C) 2010-2024 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

"""
Test suite for making push/pull operations, on specially modified INI files
"""

import pytest


from rhodecode.tests import GIT_REPO, HG_REPO
from rhodecode.tests.vcs_operations import Command, _add_files_and_push
from rhodecode.tests.vcs_operations.conftest import check_httpbin_connection


connection_available = pytest.mark.skipif(
    not check_httpbin_connection(), reason="No outside internet connection available"
)


@pytest.mark.usefixtures(
    "init_pyramid_app",
    "repo_group_repos",
    "disable_anonymous_user",
    "disable_locking",
    "enable_webhook_push_integration",
)
class TestVCSOperationsOnIntegrationsTrigger(object):
    def test_push_with_webhook_hg(self, rcstack, tmpdir):
        clone_url = rcstack.repo_clone_url(HG_REPO)

        Command(tmpdir.strpath).execute("hg clone", clone_url, tmpdir.strpath)

        push_url = rcstack.repo_clone_url(HG_REPO)
        _add_files_and_push("hg", tmpdir.strpath, clone_url=push_url)

        celery_log = open(rcstack.rcstack_data.celery_log).read()
        assert "ERROR" not in celery_log
        assert "executing task TASK:<@task: rhodecode.integrations.types.webhook.post_to_webhook" in celery_log
        assert (
            "handling event repo-push with integration <rhodecode.integrations.types.webhook.WebhookIntegrationType"
            in celery_log
        )

    def test_push_with_webhook_git(self, rcstack, tmpdir):
        clone_url = rcstack.repo_clone_url(GIT_REPO)

        Command(tmpdir.strpath).execute("git clone", clone_url, tmpdir.strpath)

        push_url = rcstack.repo_clone_url(GIT_REPO)
        _add_files_and_push("git", tmpdir.strpath, clone_url=push_url)

        celery_log = open(rcstack.rcstack_data.celery_log).read()
        assert "ERROR" not in celery_log
        assert "executing task TASK:<@task: rhodecode.integrations.types.webhook.post_to_webhook" in celery_log
        assert (
            "handling event repo-push with integration <rhodecode.integrations.types.webhook.WebhookIntegrationType"
            in celery_log
        )

    @pytest.mark.xfail(reason="Lack of proper SVN support of cloning")
    def test_push_with_webhook_svn(self, rcstack, tmpdir):
        raise Exception("Not implemented")
